---
title: Applying SVG effects to HTML content
slug: Web/SVG/Applying_SVG_effects_to_HTML_content
tags:
  - CSS
  - Guide
  - HTML
  - SVG
---
<p>Modern browsers support using <a href="/en-US/docs/SVG">SVG</a> within <a href="/en-US/docs/Web/CSS" title="Cascading Style Sheets">CSS</a> styles to apply graphical effects to HTML content.</p>

<p>You may specify SVG in styles either within the same document or an external style sheet. There are 3 properties you can use: <a href="/en-US/docs/Web/CSS/mask"><code>mask</code></a>, <a href="/en-US/docs/Web/CSS/clip-path"><code>clip-path</code></a>, and <a href="/en-US/docs/Web/CSS/filter"><code>filter</code></a>.</p>

<div class="note"><strong>Note:</strong> References to SVG in external files must be to the <a href="/en-US/docs/Web/Security/Same-origin_policy">same origin</a> as the referencing document.</div>

<h2 id="Using_embedded_SVG">Using embedded SVG</h2>

<p>To apply an SVG effect using CSS styles, you first need to create the CSS style that references the SVG to apply.</p>

<pre class="brush: html">&lt;style&gt;p { mask: url(#my-mask); }&lt;/style&gt;
</pre>

<p>In the above example, all paragraphs are masked by an <a href="/en-US/docs/Web/SVG/Element/mask">SVG <code>&lt;mask&gt;</code></a> with the <a href="/en-US/docs/Web/HTML/Global_attributes/id">ID</a> <code>my-mask</code>.</p>

<h3 id="Example_Masking">Example: Masking</h3>

<p>For example, you can make a gradient mask for HTML content using SVG and CSS code similar to the following, inside your HTML document:</p>

<pre class="brush: html">&lt;svg height="0"&gt;
  &lt;mask id="mask-1"&gt;
    &lt;linearGradient id="gradient-1" y2="1"&gt;
      &lt;stop stop-color="white" offset="0"/&gt;
      &lt;stop stop-opacity="0" offset="1"/&gt;
    &lt;/linearGradient&gt;
    &lt;circle cx="0.25" cy="0.25" r="0.25" id="circle" fill="white"/&gt;
    &lt;rect x="0.5" y="0.2" width="300" height="100" fill="url(#gradient-1)"/&gt;
  &lt;/mask&gt;
&lt;/svg&gt;
</pre>

<pre class="brush: css">.target {
  mask: url(#mask-1);
}
p {
  width: 300px;
  border: 1px solid #000;
  display: inline-block;
}</pre>

<p>Note that in the CSS, the mask is specified using a URL to the ID <code>#mask-1</code>, which is the ID of the SVG mask specified below it. Everything else specifies details about the gradient mask itself.</p>

<p>Applying the SVG effect to (X)HTML is accomplished by assigning the <code>target</code> class defined above to an element, like this:</p>

<pre class="brush: html">&lt;p class="target" style="background:lime;"&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua. Ut enim ad minim veniam.
&lt;/p&gt;
&lt;p&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing
    &lt;b class="target"&gt;elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua.&lt;/b&gt;
    Ut enim ad minim veniam.
&lt;/p&gt;
</pre>

<p>The above example would be rendered with the mask applied to it.</p>

<p>{{EmbedLiveSample('Example_Masking', 650, 200)}}</p>

<h3 id="Example_Clipping">Example: Clipping</h3>

<p>This example demonstrates using SVG to clip HTML content. Notice that even the clickable areas for links are clipped.</p>

<pre class="brush: html">&lt;p class="target" style="background:lime;"&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua. Ut enim ad minim veniam.
&lt;/p&gt;
&lt;p&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing
    &lt;b class="target"&gt;elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua.&lt;/b&gt;
    Ut enim ad minim veniam.
&lt;/p&gt;

&lt;button onclick="toggleRadius()"&gt;Toggle radius&lt;/button&gt;

&lt;svg height="0"&gt;
  &lt;clipPath id="clipping-path-1" clipPathUnits="objectBoundingBox"&gt;
    &lt;circle cx="0.25" cy="0.25" r="0.25" id="circle"/&gt;
    &lt;rect x="0.5" y="0.2" width="0.5" height="0.8"/&gt;
  &lt;/clipPath&gt;
&lt;/svg&gt;
</pre>

<pre class="brush: css">.target {
  clip-path: url(#clipping-path-1);
}
p {
  width: 300px;
  border: 1px solid #000;
  display: inline-block;
}</pre>

<p>This establishes a clipping area made of a circle and rectangle, assigns it the ID <code>#clipping-path-1</code>, then references it in the CSS. The clip path can be assigned to any element with the <code>target</code> class.</p>

<p>You can make changes to the SVG in real time and see them immediately affect the rendering of the HTML. For example, you can resize the circle in the clip path established above:</p>

<pre class="brush: js">function toggleRadius() {
  var circle = document.getElementById("circle");
  circle.r.baseVal.value = 0.40 - circle.r.baseVal.value;
}
</pre>

<p>{{EmbedLiveSample('Example_Clipping', 650, 200)}}</p>

<h3 id="Example_Filtering">Example: Filtering</h3>

<p>This demonstrates applying a filter to HTML content using SVG. It establishes several filters, which are applied with CSS to three elements in both the normal and mouse <a href="/en-US/docs/Web/CSS/:hover">hover</a> states.</p>

<pre class="brush: html">&lt;p class="target" style="background: lime;"&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua. Ut enim ad minim veniam.
&lt;/p&gt;
&lt;pre class="target"&gt;lorem&lt;/pre&gt;
&lt;p&gt;
    Lorem ipsum dolor sit amet, consectetur adipisicing
    &lt;b class="target"&gt;elit, sed do eiusmod tempor incididunt
    ut labore et dolore magna aliqua.&lt;/b&gt;
    Ut enim ad minim veniam.
&lt;/p&gt;
</pre>

<p>Any SVG filter can be applied this way. For example, to apply a blur effect, you might use:</p>

<pre class="brush: html">&lt;svg height="0"&gt;
  &lt;filter id="f1"&gt;
    &lt;feGaussianBlur stdDeviation="3"/&gt;
  &lt;/filter&gt;
&lt;/svg&gt;</pre>

<p>You could also apply a color matrix:</p>

<pre class="brush: html">&lt;svg height="0"&gt;
  &lt;filter id="f2"&gt;
    &lt;feColorMatrix values="0.3333 0.3333 0.3333 0 0
                           0.3333 0.3333 0.3333 0 0
                           0.3333 0.3333 0.3333 0 0
                           0      0      0      1 0"/&gt;
  &lt;/filter&gt;
&lt;/svg&gt;
</pre>

<p>And some more filters:</p>

<pre class="brush: html"><span>&lt;svg height="0"&gt;
</span>  &lt;filter id="f3"&gt;
    &lt;feConvolveMatrix filterRes="100 100" style="color-interpolation-filters:sRGB"
      order="3" kernelMatrix="0 -1 0   -1 4 -1   0 -1 0" preserveAlpha="true"/&gt;
  &lt;/filter&gt;
  &lt;filter id="f4"&gt;
    &lt;feSpecularLighting surfaceScale="5" specularConstant="1"
                        specularExponent="10" lighting-color="white"&gt;
      &lt;fePointLight x="-5000" y="-10000" z="20000"/&gt;
    &lt;/feSpecularLighting&gt;
  &lt;/filter&gt;
  &lt;filter id="f5"&gt;
    &lt;feColorMatrix values="1 0 0 0 0
                           0 1 0 0 0
                           0 0 1 0 0
                           0 1 0 0 0" style="color-interpolation-filters:sRGB"/&gt;
  &lt;/filter&gt;
<span>&lt;/svg&gt;</span></pre>

<p>The five filters are applied using the following CSS:</p>

<pre class="brush: css">p.target { filter:url(#f3); }
p.target:hover { filter:url(#f5); }
b.target { filter:url(#f1); }
b.target:hover { filter:url(#f4); }
pre.target { filter:url(#f2); }
pre.target:hover { filter:url(#f3); }
</pre>

<p>{{EmbedLiveSample('Example_Filtering', 650, 200)}}</p>

<p style="display: none;"><a class="button liveSample" href="/files/3329/filterdemo.xhtml">View this example live</a></p>

<h3 id="Example_Blurred_Text">Example: Blurred Text</h3>

<p>In order to blur text, Webkit based browsers have a (prefixed) CSS filter called blur (see also <a href="/en-US/docs/Web/CSS/filter#blur%28%29_2">CSS filter</a>). You can achieve the same effect using SVG filters.</p>

<pre class="brush: html">&lt;p class="blur"&gt;Time to clean my glasses&lt;/p&gt;
&lt;svg height="0"&gt;
  &lt;defs&gt;
    &lt;filter id="wherearemyglasses" x="0" y="0"&gt;
    &lt;feGaussianBlur in="SourceGraphic" stdDeviation="1"/&gt;
    &lt;/filter&gt;
  &lt;/defs&gt;
&lt;/svg&gt;
</pre>

<p>You can apply the SVG and the CSS filter in the same class:</p>

<pre class="brush: css">.blur { filter: url(#wherearemyglasses); }</pre>

<p>{{ EmbedLiveSample('Example_Blurred_Text', 300, 100) }}</p>

<p>Blurring is computation heavy, so ensure to use it sparingly, especially in elements that get scrolled or animated.</p>



<h3 id="Example_Text_Effects">Example: Text Effects</h3>

<p>SVG effects can also be used to add a more dynamic and flexible approach to adding text compared to plain HTML text. </p>

<p>By creating the text using SVG elements combined with HTML you can make a variety of different text effects. You can rotate the text:</p>

<pre class="brush: html">&lt;svg height="60" width="200"&gt;
  &lt;text x="0" y="15" fill="blue" transform="rotate(30 20,50)"&gt;Example text&lt;/text&gt;
&lt;/svg&gt;
</pre>

<h2 id="Using_external_references">Using external references</h2>

<p>SVG used for clipping, masking, and filtering can be loaded from an external source, as long as that source comes from the same origin as the HTML document to which it's applied.</p>

<p>For example, if your CSS is in a file named <code>default.css</code>, it can look like this:</p>

<pre class="brush: css" id="line1">.target { clip-path: url(resources.svg#c1); }</pre>

<p>The SVG is then imported from a file named <code>resources.svg</code>, using the clip path with the ID <code>c1</code>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/SVG" title="SVG">SVG</a></li>
 <li><a class="external" href="http://robert.ocallahan.org/2008/06/applying-svg-effects-to-html-content_04.html">SVG Effects for HTML Content</a> (blog post)</li>
 <li><del><a class="external" href="/web-tech/2008/10/10/svg-external-document-references">SVG External Document References</a></del> (blog post) (<a href="http://web.archive.org/web/20120512132948/https://developer.mozilla.org/web-tech/2008/10/10/svg-external-document-references/" title="Web Tech Blog » Blog Archive » SVG External Document References">[archive.org] Web Tech Blog » Blog Archive » SVG External Document References</a>)</li>
</ul>
